# Class PokemonForm

#### Hierarchy (view full)

- PokemonSpeciesForm
  - PokemonForm

- Defined in src/data/pokemon-species.ts:831

#####
Index

### Constructors

constructor

### Properties

ability1
ability2
abilityHidden
baseExp
baseFriendship
baseStats
baseTotal
catchRate
formIndex
formKey
formName
formSpriteKey
genderDiffs
generation
height
isStarterSelectable
speciesId
starterSelectableKeys
type1
type2
weight

### Methods

cry
generateCandyColors
getAbility
getAbilityCount
getBaseExp
getBaseStat
getCryKey
getFormSpriteKey
getIconAtlasKey
getIconId
getLevelMoves
getRegion
getRootSpeciesId
getSpriteAtlasPath
getSpriteId
getSpriteKey
getVariantDataIndex
isCatchable
isObtainable
isOfType
isRareRegional
isRegional
isTrainerForbidden
loadAssets
validateStarterMoveset

## Constructors

### constructor

- new PokemonForm(formName, formKey, type1, type2, height, weight, ability1, ability2, abilityHidden, baseTotal, baseHp, baseAtk, baseDef, baseSpatk, baseSpdef, baseSpd, catchRate, baseFriendship, baseExp, genderDiffs?, formSpriteKey?, isStarterSelectable?): PokemonForm

- #### Parameters

  - formName: string
  - formKey: string
  - type1: Type
  - type2: Type
  - height: number
  - weight: number
  - ability1: Abilities
  - ability2: Abilities
  - abilityHidden: Abilities
  - baseTotal: number
  - baseHp: number
  - baseAtk: number
  - baseDef: number
  - baseSpatk: number
  - baseSpdef: number
  - baseSpd: number
  - catchRate: number
  - baseFriendship: number
  - baseExp: number
  - `Optional` genderDiffs: boolean
  - `Optional` formSpriteKey: string
  - `Optional` isStarterSelectable: boolean

  #### Returns PokemonForm

  Overrides PokemonSpeciesForm.constructor

  - Defined in src/data/pokemon-species.ts:839

## Properties

### ability1

ability1: Abilities

Inherited from PokemonSpeciesForm.ability1

- Defined in src/data/pokemon-species.ts:129

### ability2

ability2: Abilities

Inherited from PokemonSpeciesForm.ability2

- Defined in src/data/pokemon-species.ts:130

### abilityHidden

abilityHidden: Abilities

Inherited from PokemonSpeciesForm.abilityHidden

- Defined in src/data/pokemon-species.ts:131

### baseExp

baseExp: number

Inherited from PokemonSpeciesForm.baseExp

- Defined in src/data/pokemon-species.ts:136

### baseFriendship

baseFriendship: number

Inherited from PokemonSpeciesForm.baseFriendship

- Defined in src/data/pokemon-species.ts:135

### baseStats

baseStats: number[]

Inherited from PokemonSpeciesForm.baseStats

- Defined in src/data/pokemon-species.ts:133

### baseTotal

baseTotal: number

Inherited from PokemonSpeciesForm.baseTotal

- Defined in src/data/pokemon-species.ts:132

### catchRate

catchRate: number

Inherited from PokemonSpeciesForm.catchRate

- Defined in src/data/pokemon-species.ts:134

### formIndex

formIndex: number

Inherited from PokemonSpeciesForm.formIndex

- Defined in src/data/pokemon-species.ts:123

### formKey

formKey: string

- Defined in src/data/pokemon-species.ts:833

### formName

formName: string

- Defined in src/data/pokemon-species.ts:832

### formSpriteKey

formSpriteKey: string

- Defined in src/data/pokemon-species.ts:834

### genderDiffs

genderDiffs: boolean

Inherited from PokemonSpeciesForm.genderDiffs

- Defined in src/data/pokemon-species.ts:137

### generation

generation: number

Inherited from PokemonSpeciesForm.generation

- Defined in src/data/pokemon-species.ts:124

### height

height: number

Inherited from PokemonSpeciesForm.height

- Defined in src/data/pokemon-species.ts:127

### isStarterSelectable

isStarterSelectable: boolean

Inherited from PokemonSpeciesForm.isStarterSelectable

- Defined in src/data/pokemon-species.ts:138

### speciesId

speciesId: Species

Inherited from PokemonSpeciesForm.speciesId

- Defined in src/data/pokemon-species.ts:122

### `Private` starterSelectableKeys

starterSelectableKeys: string[] = ...

- Defined in src/data/pokemon-species.ts:837

### type1

type1: Type

Inherited from PokemonSpeciesForm.type1

- Defined in src/data/pokemon-species.ts:125

### type2

type2: Type

Inherited from PokemonSpeciesForm.type2

- Defined in src/data/pokemon-species.ts:126

### weight

weight: number

Inherited from PokemonSpeciesForm.weight

- Defined in src/data/pokemon-species.ts:128

## Methods

### cry

- cry(scene, soundConfig?, ignorePlay?): AnySound

- #### Parameters

  - scene: default
  - `Optional` soundConfig: SoundConfig
  - `Optional` ignorePlay: boolean

  #### Returns AnySound

  Inherited from PokemonSpeciesForm.cry

  - Defined in src/data/pokemon-species.ts:488

### generateCandyColors

- generateCandyColors(scene): number[][]

- #### Parameters

  - scene: default

  #### Returns number[][]

  Inherited from PokemonSpeciesForm.generateCandyColors

  - Defined in src/data/pokemon-species.ts:501

### getAbility

- getAbility(abilityIndex): Abilities

- #### Parameters

  - abilityIndex: number

  #### Returns Abilities

  Inherited from PokemonSpeciesForm.getAbility

  - Defined in src/data/pokemon-species.ts:182

### getAbilityCount

- getAbilityCount(): number

- #### Returns number

  Inherited from PokemonSpeciesForm.getAbilityCount

  - Defined in src/data/pokemon-species.ts:178

### getBaseExp

- getBaseExp(): number

- #### Returns number

  Inherited from PokemonSpeciesForm.getBaseExp

  - Defined in src/data/pokemon-species.ts:231

### getBaseStat

- getBaseStat(stat): number

- Gets the species' base stat amount for the given stat.

  #### Parameters

  - stat: Stat

    The desired stat.

  #### Returns number

  The species' base stat amount.

  Inherited from PokemonSpeciesForm.getBaseStat

  - Defined in src/data/pokemon-species.ts:227

### getCryKey

- getCryKey(formIndex?): string

- #### Parameters

  - `Optional` formIndex: number

  #### Returns string

  Inherited from PokemonSpeciesForm.getCryKey

  - Defined in src/data/pokemon-species.ts:347

### getFormSpriteKey

- getFormSpriteKey(_formIndex?): string

- #### Parameters

  - `Optional` _formIndex: number

  #### Returns string

  Overrides PokemonSpeciesForm.getFormSpriteKey

  - Defined in src/data/pokemon-species.ts:849

### getIconAtlasKey

- getIconAtlasKey(formIndex?, shiny?, variant?): string

- #### Parameters

  - `Optional` formIndex: number
  - `Optional` shiny: boolean
  - `Optional` variant: number

  #### Returns string

  Inherited from PokemonSpeciesForm.getIconAtlasKey

  - Defined in src/data/pokemon-species.ts:293

### getIconId

- getIconId(female, formIndex?, shiny?, variant?): string

- #### Parameters

  - female: boolean
  - `Optional` formIndex: number
  - `Optional` shiny: boolean
  - `Optional` variant: number

  #### Returns string

  Inherited from PokemonSpeciesForm.getIconId

  - Defined in src/data/pokemon-species.ts:299

### getLevelMoves

- getLevelMoves(): LevelMoves

- #### Returns LevelMoves

  Inherited from PokemonSpeciesForm.getLevelMoves

  - Defined in src/data/pokemon-species.ts:186

### getRegion

- getRegion(): Region

- #### Returns Region

  Inherited from PokemonSpeciesForm.getRegion

  - Defined in src/data/pokemon-species.ts:193

### getRootSpeciesId

- getRootSpeciesId(forStarter?): Species

- Method to get the root species id of a Pokemon. Magmortar.getRootSpeciesId(true) => Magmar Magmortar.getRootSpeciesId(false) => Magby

  #### Parameters

  - forStarter: boolean = false

    boolean to get the nonbaby form of a starter

  #### Returns Species

  The species

  Inherited from PokemonSpeciesForm.getRootSpeciesId

  - Defined in src/data/pokemon-species.ts:166

### getSpriteAtlasPath

- getSpriteAtlasPath(female, formIndex?, shiny?, variant?): string

- #### Parameters

  - female: boolean
  - `Optional` formIndex: number
  - `Optional` shiny: boolean
  - `Optional` variant: number

  #### Returns string

  Inherited from PokemonSpeciesForm.getSpriteAtlasPath

  - Defined in src/data/pokemon-species.ts:246

### getSpriteId

- getSpriteId(female, formIndex?, shiny?, variant?, back?): string

- #### Parameters

  - female: boolean
  - `Optional` formIndex: number
  - `Optional` shiny: boolean
  - `Optional` variant: number
  - `Optional` back: boolean

  #### Returns string

  Inherited from PokemonSpeciesForm.getSpriteId

  - Defined in src/data/pokemon-species.ts:251

### getSpriteKey

- getSpriteKey(female, formIndex?, shiny?, variant?): string

- #### Parameters

  - female: boolean
  - `Optional` formIndex: number
  - `Optional` shiny: boolean
  - `Optional` variant: number

  #### Returns string

  Inherited from PokemonSpeciesForm.getSpriteKey

  - Defined in src/data/pokemon-species.ts:268

### getVariantDataIndex

- getVariantDataIndex(formIndex?): string | number

- Variant Data key/index is either species id or species id followed by -formkey

  #### Parameters

  - `Optional` formIndex: number

    optional form index for pokemon with different forms

  #### Returns string | number

  species id if no additional forms, index with formkey if a pokemon with a form

  Inherited from PokemonSpeciesForm.getVariantDataIndex

  - Defined in src/data/pokemon-species.ts:280

### isCatchable

- isCatchable(): boolean

- #### Returns boolean

  Inherited from PokemonSpeciesForm.isCatchable

  - Defined in src/data/pokemon-species.ts:201

### isObtainable

- isObtainable(): boolean

- #### Returns boolean

  Inherited from PokemonSpeciesForm.isObtainable

  - Defined in src/data/pokemon-species.ts:197

### isOfType

- isOfType(type): boolean

- #### Parameters

  - type: number

  #### Returns boolean

  Inherited from PokemonSpeciesForm.isOfType

  - Defined in src/data/pokemon-species.ts:174

### isRareRegional

- isRareRegional(): boolean

- #### Returns boolean

  Inherited from PokemonSpeciesForm.isRareRegional

  - Defined in src/data/pokemon-species.ts:213

### isRegional

- isRegional(): boolean

- #### Returns boolean

  Inherited from PokemonSpeciesForm.isRegional

  - Defined in src/data/pokemon-species.ts:205

### isTrainerForbidden

- isTrainerForbidden(): boolean

- #### Returns boolean

  Inherited from PokemonSpeciesForm.isTrainerForbidden

  - Defined in src/data/pokemon-species.ts:209

### loadAssets

- loadAssets(scene, female, formIndex?, shiny?, variant?, startLoad?): Promise<void>

- #### Parameters

  - scene: default
  - female: boolean
  - `Optional` formIndex: number
  - `Optional` shiny: boolean
  - `Optional` variant: Variant
  - `Optional` startLoad: boolean

  #### Returns Promise<void>

  Inherited from PokemonSpeciesForm.loadAssets

  - Defined in src/data/pokemon-species.ts:434

### validateStarterMoveset

- validateStarterMoveset(moveset, eggMoves): boolean

- #### Parameters

  - moveset: StarterMoveset
  - eggMoves: number

  #### Returns boolean

  Inherited from PokemonSpeciesForm.validateStarterMoveset

  - Defined in src/data/pokemon-species.ts:413